#include "FriendsManager.h"

List <Friendslist *> *myfriends = 0;

HINSTANCE DllInstance;
HHOOK WindowHook;
HWND MainWindow;
HMENU MainMenu;
WNDPROC wpOrigListViewProc;
UINT MenuId;
HWND FriendsMgrWindow;
HWND hWndFriendslist;
DWORD incre = 0;

char lpszMyName[32] = "";
bool enteredchat = false;

/* most listview-related code taken from soupbot, with 
   necessary things adjusted, may not work well */

void InitListview(void)
{
	//Create new image list
	HIMAGELIST hiList = ImageList_Create(32, 64, ILC_COLOR16, 7, 1);

	//Load the icons into HBITMAP
	HBITMAP hbIcons = LoadBitmap(DllInstance, MAKEINTRESOURCE(IDB_ICONS));

	//Insert them into the image list
	ImageList_Add(hiList, hbIcons, NULL);

	//Attach image list to the listview
	SendMessage(hWndFriendslist, LVM_SETIMAGELIST, LVSIL_SMALL, (LPARAM)hiList);

	//Set a few colors
	SendMessage(hWndFriendslist, LVM_SETBKCOLOR, 0, (LPARAM)0x00000000);
	SendMessage(hWndFriendslist, LVM_SETTEXTBKCOLOR, 0, (LPARAM)0x00000000);
	SendMessage(hWndFriendslist, LVM_SETTEXTCOLOR, 0, (LPARAM)0xffffff);

	LVCOLUMN *lvc = new LVCOLUMN;
	lvc->mask = LVCF_WIDTH;
	/* lvc->cx = 62;
	ListView_InsertColumn(hWndFriendslist, 0, (LPARAM)lvc);
	lvc->cx = 190;
	ListView_InsertColumn(hWndFriendslist, 1, (LPARAM)lvc);
	lvc->cx = 30;
	ListView_InsertColumn(hWndFriendslist, 2, (LPARAM)lvc); */
	lvc->cx = 32;
	ListView_InsertColumn(hWndFriendslist, 0, (LPARAM)lvc);
	lvc->cx = 32;
	ListView_InsertColumn(hWndFriendslist, 1, (LPARAM)lvc);
	lvc->cx = 213;
	ListView_InsertColumn(hWndFriendslist, 2, (LPARAM)lvc);
	delete lvc;
	ListView_SetExtendedListViewStyle(hWndFriendslist, ListView_GetExtendedListViewStyle(hWndFriendslist) | LVS_EX_FULLROWSELECT | LVS_EX_SUBITEMIMAGES);
}

int GetItemIndex(char *item)
{
	int ItemCount = SendMessage(hWndFriendslist, LVM_GETITEMCOUNT, 0, 0);
	for(int i = 0; i < ItemCount; i++){
		char buffer[32] = "";
		ListView_GetItemText(hWndFriendslist, i, 0, buffer, sizeof(buffer));
		if(!stricmp(buffer, item))
			return i;
	}
	return -1;
}

void InsertItem(char *szItem, int status, int locationcode)
{
	int statusicon = 0;
	int mutualicon = 0;
	if(locationcode > 3)
		statusicon = 4;
	else
		statusicon = locationcode;
	if((status & 1) == 1)
		mutualicon = 6;
	else
		mutualicon = 5;

	SendMessage(hWndFriendslist, LVM_SETTEXTCOLOR, 0, (LPARAM)0xffffff);

	LVITEM *lviItem = new LVITEM;
	lviItem->iItem = (int)SendMessage(hWndFriendslist, LVM_GETITEMCOUNT, 0, 0);
	lviItem->mask =  LVIF_IMAGE | LVIF_TEXT;
	lviItem->iSubItem = 0;
	lviItem->iImage = statusicon;
	lviItem->pszText = szItem;
	SendMessage(hWndFriendslist, LVM_INSERTITEM, 0, (LPARAM)lviItem);
	if(locationcode) {
		lviItem->mask =  LVIF_IMAGE;
		lviItem->iSubItem = 1;
		lviItem->iImage = mutualicon;
		SendMessage(hWndFriendslist, LVM_SETITEM, 0, (LPARAM)lviItem);
	}
	lviItem->mask =  LVIF_TEXT;
	lviItem->iSubItem = 2;
	lviItem->pszText = szItem;
	SendMessage(hWndFriendslist, LVM_SETITEM, 0, (LPARAM)lviItem);
	delete lviItem;
	//SendMessage(hWndFriendslist, LVM_ARRANGE, LVA_ALIGNLEFT, 0); //So there aren't holes in the list when something is removed
}

void ModifyItem(char *item, int status, int locationcode, int addpos)
{
	int statusicon = 0;
	int mutualicon = 0;
	if(locationcode > 3)
		statusicon = 4;
	else
		statusicon = locationcode;
	if((status & 1) == 1)
		mutualicon = 6;
	else
		mutualicon = 5;

	int pos = GetItemIndex(item);

	SendMessage(hWndFriendslist, LVM_DELETEITEM, pos, 0);

	LVITEM *lviItem = new LVITEM;
	lviItem->iItem = addpos;
	lviItem->mask =  LVIF_IMAGE | LVIF_TEXT;
	lviItem->iSubItem = 0;
	lviItem->iImage = statusicon;
	lviItem->pszText = item;
	SendMessage(hWndFriendslist, LVM_INSERTITEM, 0, (LPARAM)lviItem);
	if(locationcode) {
		lviItem->mask =  LVIF_IMAGE;
		lviItem->iSubItem = 1;
		lviItem->iImage = mutualicon;
		SendMessage(hWndFriendslist, LVM_SETITEM, 0, (LPARAM)lviItem);
	}
	lviItem->mask =  LVIF_TEXT;
	lviItem->iSubItem = 2;
	lviItem->pszText = item;
	SendMessage(hWndFriendslist, LVM_SETITEM, 0, (LPARAM)lviItem);
	delete lviItem;
}

void ModifyFriendOnlinestatus(char *item, int status, int locationcode)
{
	int statusicon = 0;
	int mutualicon = 0;
	if(locationcode > 3)
		statusicon = 4;
	else
		statusicon = locationcode;
	if((status & 1) == 1)
		mutualicon = 6;
	else
		mutualicon = 5;

	int pos = GetItemIndex(item);

	LVITEM *lviItem = new LVITEM;
	lviItem->iItem = pos;
	lviItem->mask =  LVIF_IMAGE;
	lviItem->iSubItem = 0;
	lviItem->iImage = statusicon;
	SendMessage(hWndFriendslist, LVM_SETITEM, 0, (LPARAM)lviItem);
	if(locationcode) {
		lviItem->mask =  LVIF_IMAGE;
		lviItem->iSubItem = 1;
		lviItem->iImage = mutualicon;
		SendMessage(hWndFriendslist, LVM_SETITEM, 0, (LPARAM)lviItem);
	}
	delete lviItem;
}


void RemoveItem(char *item)
{
	ListView_DeleteItem(hWndFriendslist, GetItemIndex(item));
	SendMessage(hWndFriendslist, LVM_ARRANGE, LVA_ALIGNLEFT, 0);
}

LRESULT CALLBACK GetMessageHook(int nCode, WPARAM wParam, LPARAM lParam) {
	if (nCode >= 0) {
		MSG& msg = *reinterpret_cast<LPMSG>(lParam);
		switch (msg.message) {
		case WM_COMMAND:
			if (msg.hwnd == MainWindow && !HIWORD(msg.wParam)) {
				if (msg.wParam == MenuId) {
					if (!FriendsMgrWindow)
						FriendsMgrWindow = CreateDialogParamW(DllInstance, (LPCWSTR)MAKEINTRESOURCE(IDD_FRIENDSMANAGER), MainWindow, &FriendsMgrDialogProc, 0);
				}
			}
			break;
		}
	}

	return CallNextHookEx(WindowHook, nCode, wParam, lParam);

}

BOOL CALLBACK FriendsMgrDialogProc(HWND hDlg, UINT msg, WPARAM w, LPARAM l) {
	HICON hIcon;
	switch(msg) {
	case WM_CLOSE:
		DestroyWindow(hDlg);
		return 1;
	case WM_INITDIALOG:
		{
			EnableMenuItem(MainMenu, MenuId, MF_GRAYED);
			hIcon = (HICON)SendMessage(MainWindow, WM_GETICON, ICON_SMALL, 0);
			SetClassLong(hDlg, GCL_HICONSM, (LONG)hIcon);
			SendMessage(GetDlgItem(hDlg, IDC_MOTD), EM_SETBKGNDCOLOR, 0, (LPARAM)0xffffff);
			hWndFriendslist = GetDlgItem(hDlg, IDC_FRIENDSLIST);
			InitListview();
			wpOrigListViewProc = (WNDPROC)SetWindowLong(hWndFriendslist, GWL_WNDPROC, (LONG)ListViewSubclass); 
			requestfriendslist();
			ShowWindow(hDlg, SW_SHOWNORMAL);
			return 1;
		}
	case WM_COMMAND:
		switch (HIWORD (w)) {
		case BN_CLICKED:
			switch (LOWORD(w)) {
			case IDC_ADD:
				{
					/* add name to friends */
					char buf[128] = "";
					char addfriend[32] = "";
					GetDlgItemText(hDlg, IDC_ADDFRIEND, addfriend, 32);
					wsprintf(buf, "/f a %s", addfriend);
					API.ProcessBotCommand(buf);
				}
				break;
			case IDC_OK:
				DestroyWindow(hDlg);
				break;
			}
		}
		return 1;
	case WM_DESTROY:
		EnableMenuItem(MainMenu, MenuId, MF_ENABLED);
		FriendsMgrWindow = 0;
	}
	return 0;
}

LRESULT APIENTRY ListViewSubclass(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{ 
    if (uMsg == WM_GETDLGCODE) 
        return DLGC_WANTALLKEYS;  

	switch(uMsg) {
	case WM_INITDIALOG:
		{
			ShowScrollBar(hWndFriendslist, SB_HORZ, FALSE);
			break;
		}
	case WM_CONTEXTMENU:
		{
			int x = LOWORD(lParam);
			int y = HIWORD(lParam);

			int selected = ListView_GetSelectionMark(hWndFriendslist);
			if(selected == -1)
				return CallWindowProc(wpOrigListViewProc, hwnd, uMsg, 
									  wParam, lParam);

			char SelectedText[35];
			ListView_GetItemText(hWndFriendslist, selected, 0, SelectedText, sizeof(SelectedText));
			if(strlen(SelectedText) <= 1)
				return CallWindowProc(wpOrigListViewProc, hwnd, uMsg, 
									  wParam, lParam);

			HMENU hmMenu, hmSubMenu;
			BYTE targetrank = 0;
			hmMenu = LoadMenu( DllInstance, MAKEINTRESOURCE( IDR_POPUP ));
			hmSubMenu = GetSubMenu( hmMenu, 0 );

			/* due to bnet being buggy, can't do this */
			//showtext(PluginAPI::Yellow, "getting latest status for %u\r\n", selected);
			INT length = 0x1;
			LPBYTE data = (LPBYTE)alloca(length);
			*(PDWORD)&data[0] = selected;
			API.QueueMessage(0x66, data, length);

			BOOL nRetID = TrackPopupMenuEx( hmSubMenu, TPM_LEFTALIGN |
			TPM_TOPALIGN | TPM_NONOTIFY | TPM_RETURNCMD |
			TPM_RIGHTBUTTON, x, y, FriendsMgrWindow, NULL );

			char buf[128] = "";
			switch(nRetID) {
			case ID_POPUP_WHOIS:
				{
					wsprintf(buf, "/whois %s", SelectedText);
					API.ProcessBotCommand(buf);
				}
				break;
			case ID_POPUP_PROFILE:
				{
					wsprintf(buf, "/profile %s", SelectedText);
					API.ProcessBotCommand(buf);
				}
				break;
			case ID_POPUP_WEBPROFILE:
				{
					/* char weburl[128] = "";
					wsprintf(weburl, "http://www.battle.net/war3/ladder/%s-player-profile.aspx?Gateway=%s&PlayerName=%s", product, gateway, playername);
					ShellExecuteA(0, 0, weburl, 0, 0, SW_SHOW); */
				}
				break;
			case ID_POPUP_PROMOTE:
				{
					wsprintf(buf, "/f p %s", SelectedText);
					API.ProcessBotCommand(buf);
				}
				break;
			case ID_POPUP_DEMOTE:
				{
					wsprintf(buf, "/f d %s", SelectedText);
					API.ProcessBotCommand(buf);
				}
				break;
			case ID_POPUP_REMOVE:
				{
					wsprintf(buf, "/f r %s", SelectedText);
					API.ProcessBotCommand(buf);
				}
				break;
			}

			DestroyMenu(hmSubMenu);
			DestroyMenu(hmMenu);
			break;
		}
	}

    return CallWindowProc(wpOrigListViewProc, hwnd, uMsg, 
        wParam, lParam); 
} 

void showtext(PluginAPI::OutputColor Color, const char *text, ...) {
	char msg[512] = "";
	va_list argptr;
	va_start(argptr, text);
	vsprintf(msg, text, argptr);
	va_end(argptr);
	API.WriteOutputTimestamp();
	API.SetOutputColor(Color);
	API.WriteOutputString(msg);
}

void resetfriendsdata(void) {
	for (int i = 0; i < 5; i++) {
		Friendslist *remove = 0;
		myfriends->rewind();
		while(!myfriends->at_end()) {
			remove = myfriends->get();
			myfriends->remove(remove);
		}
	}
	if(FriendsMgrWindow)
		ListView_DeleteAllItems(hWndFriendslist);
}

void purgefriendslist(void) {
	Friendslist *remove = 0;
	myfriends->rewind();
	while(!myfriends->at_end()) {
		remove = myfriends->get();
		myfriends->remove(remove);
	}
}

void requestfriendslist(void) {
	if(enteredchat) {
		//showtext(PluginAPI::Yellow, "Requesting friends list ...\r\n");
		INT length = 0x0;
		LPBYTE data = 0;
		API.QueueMessage(0x65, data, length);
	}
}

void buildfriendslist(void) {
	if(SendMessage(hWndFriendslist, LVM_GETITEMCOUNT, 0, 0) > 0)
		ListView_DeleteAllItems(hWndFriendslist);

	List <Friendslist *> *templist = new List <Friendslist *>;
	Friendslist *currentuser = 0;

	reverselist(myfriends, templist);
	while(!templist->at_end()) {
		currentuser = templist->get();
		char currentname[64] = "";
		currentuser->GetName(currentname);
		InsertItem(currentname, (int)currentuser->GetStatus(), (int)currentuser->GetLocationCode());
		templist->remove(currentuser);
	}
	delete templist;
}

void reverselist(List <Friendslist *> *sourcelist, List <Friendslist *> *destlist) {
	sourcelist->rewind();
	destlist->rewind();
	while(!sourcelist->at_end()) {
		destlist->add(sourcelist->get());
		++*sourcelist;
	}
	sourcelist->rewind();
	destlist->rewind();
}

void clearlist(List <Friendslist *> *targetlist) {
	Friendslist *remove = 0;
	targetlist->rewind();
	while(!targetlist->at_end()) {
		remove = targetlist->get();
		targetlist->remove(remove);
	}
}
